package edu.uncc.grid.example.workpool;

import java.util.logging.Level;

import edu.uncc.grid.pgaf.datamodules.Data;
import edu.uncc.grid.pgaf.datamodules.DataMap;
import edu.uncc.grid.pgaf.interfaces.basic.Workpool;
import edu.uncc.grid.pgaf.p2p.Node;

public class MatrixMultModule extends Workpool {

	private static final long serialVersionUID = 1L;

	int[][] matrixA;
	int[][] matrixB;
	int[][] matrixC;

	public MatrixMultModule() {		
		matrixC = new int[3][3];
	}
			
	public void initMatrices(){	
		matrixA = new int[][]{	{3,6,7},
								{7,4,9},
								{9,5,7}};
		
		matrixB = new int[][]{	{3,6,7},
								{7,4,9},
								{9,5,7}};		
	}

	public int getDataCount() {
		return 9;
	}

	public void initializeModule(String[] args) {
	
		Node.getLog().setLevel(Level.WARNING);		
	}
	
	public Data DiffuseData(int segment) {

		int[] rowA = new int[3];
		int[] colB = new int[3];

		DataMap<String, int[]> d =new DataMap<String, int[]>();

		int a=segment/3, b = segment%3;
		for (int i=0;i<3;i++){		//Copy one row of A and one column of B into d
			rowA[i] = matrixA[a][i];
			colB[i] = matrixB[i][b];
		}

		d.put("rowA",rowA);
		d.put("colB",colB);
		
		return d;
	}

	public Data Compute(Data data) {

		DataMap<String, int[]> input = (DataMap<String,int[]>)data;
		DataMap<String, Integer> output = new DataMap<String, Integer>();

		int[] rowA = (int[]) input.get("rowA");
		int[] colB = (int[]) input.get("colB");

		//computation
	
		int out = 0;
		for (int i=0;i<3;i++) {
			out += rowA[i] * colB[i];
		}
 							
		output.put("out",out);	
		
		return output;
	}
	
	public void GatherData(int segment, Data dat) {

		DataMap<String,Integer> out = (DataMap<String,Integer>) dat;

		int answer = out.get("out");
					
		int a=segment/3, b=segment%3;
		matrixC[a][b]= answer;

	}
	
	public void printResult(){

		for (int i=0;i<3;i++){
			System.out.println();	
			for(int j=0;j<3;j++){			
				System.out.print(matrixC[i][j] + "  ");			
			}	
		}
		System.out.println();	
	}

}       // end of MatrixMultiplyModule

